diff --git a/vm/src/from_squeak/intplugins/BitBltPlugin/BitBltPlugin.c b/vm/src/from_squeak/intplugins/BitBltPlugin/BitBltPlugin.c
index e0b6a5e..997eec0 100644
--- a/vm/src/from_squeak/intplugins/BitBltPlugin/BitBltPlugin.c
+++ b/vm/src/from_squeak/intplugins/BitBltPlugin/BitBltPlugin.c
@@ -2804,7 +2833,7 @@ l4:	/* end loadBitBltDestForm */;
 			cmShiftTable = interpreterProxy->firstIndexableField(mapOop);
 		l6:	/* end loadColorMapShiftOrMaskFrom: */;
 			/* begin loadColorMapShiftOrMaskFrom: */
-			mapOop1 = interpreterProxy->fetchPointerofObject(1, cmOop);
+			mapOop1 = interpreterProxy->fetchPointerofObject(1, cmOop); // OK xxx_dmu
 			if (mapOop1 == (interpreterProxy->nilObject())) {
 				cmMaskTable = null;
 				goto l7;
@@ -2821,11 +2850,12 @@ l4:	/* end loadBitBltDestForm */;
 			}
 			cmMaskTable = interpreterProxy->firstIndexableField(mapOop1);
 		l7:	/* end loadColorMapShiftOrMaskFrom: */;
-			oop = interpreterProxy->fetchPointerofObject(2, cmOop);
+			oop = interpreterProxy->fetchPointerofObject(2, cmOop); // maybe xxx_dmu
 			if (oop == (interpreterProxy->nilObject())) {
 				cmSize = 0;
 			} else {
 				if (!(interpreterProxy->isWords(oop))) {
+          //fprintf(stderr, "failed 2849\n");
 					ok = 0;
 					goto l8;
 				}
@@ -2835,6 +2865,7 @@ l4:	/* end loadBitBltDestForm */;
 			cmFlags = cmFlags | ColorMapNewStyle;
 		}
 		if (!((cmSize & (cmSize - 1)) == 0)) {
+      //fprintf(stderr, "failed 2859\n");
 			ok = 0;
 			goto l8;
 		}
@@ -2867,6 +2898,7 @@ l4:	/* end loadBitBltDestForm */;
 		ok = 1;
 	l8:	/* end loadColorMap */;
 		if (!(ok)) {
+      //fprintf(stderr, "failed 2883\n");
 			return 0;
 		}
 		if ((cmFlags & ColorMapNewStyle) == 0) {
@@ -2889,16 +2921,19 @@ l4:	/* end loadBitBltDestForm */;
 		}
 	} else {
 		if (!((!(interpreterProxy->isPointers(halftoneForm))) && (interpreterProxy->isWords(halftoneForm)))) {
+      //fprintf(stderr, "failed 2906\n");
 			ok = 0;
 			goto l5;
 		}
 		halftoneBits = halftoneForm;
 		halftoneHeight = interpreterProxy->slotSizeOf(halftoneBits);
 	}
-	halftoneBase = oopForPointer(interpreterProxy->firstIndexableField(halftoneBits));
+	// xxx_dmu halftoneBase = oopForPointer(interpreterProxy->firstIndexableField(halftoneBits));
+  halftoneBase = (sqInt)(interpreterProxy->firstIndexableField(halftoneBits));
 	ok = 1;
 l5:	/* end loadHalftoneForm */;
 	if (!(ok)) {
+    //fprintf(stderr, "failed 2918\n");
 		return 0;
 	}
 	clipX = fetchIntOrFloatofObjectifNil(BBClipXIndex, bitBltOop, 0);
@@ -2906,6 +2941,7 @@ l5:	/* end loadHalftoneForm */;
 	clipWidth = fetchIntOrFloatofObjectifNil(BBClipWidthIndex, bitBltOop, destWidth);
 	clipHeight = fetchIntOrFloatofObjectifNil(BBClipHeightIndex, bitBltOop, destHeight);
 	if (interpreterProxy->failed()) {
+    //fprintf(stderr, "failed 2926\n");
 		return 0;
 	}
 	if (clipX < 0) {
@@ -2931,7 +2967,7 @@ l5:	/* end loadHalftoneForm */;
 static sqInt loadBitBltSourceForm(void) {
     sqInt sourceBitsSize;
 
-	sourceBits = interpreterProxy->fetchPointerofObject(FormBitsIndex, sourceForm);
+	sourceBitsOop_xxx_dmu = interpreterProxy->fetchPointerofObject(FormBitsIndex, sourceForm); // maybe xxx_dmu
 	sourceWidth = fetchIntOrFloatofObject(FormWidthIndex, sourceForm);
 	sourceHeight = fetchIntOrFloatofObject(FormHeightIndex, sourceForm);
 	if (!((sourceWidth >= 0) && (sourceHeight >= 0))) {
@@ -2942,8 +2978,8 @@ static sqInt loadBitBltSourceForm(void) {
 	if (sourceDepth < 0) {
 		sourceDepth = 0 - sourceDepth;
 	}
-	if ((sourceBits & 1)) {
-		if (!(querySourceSurface((sourceBits >> 1)))) {
+	if ((sourceBitsOop_xxx_dmu & 1)) {
+		if (!(querySourceSurface((sourceBitsOop_xxx_dmu >> 1)))) {
 			return 0;
 		}
 		sourcePPW = 32 / sourceDepth;
@@ -2951,18 +2987,19 @@ static sqInt loadBitBltSourceForm(void) {
 	} else {
 		sourcePPW = 32 / sourceDepth;
 		sourcePitch = ((sourceWidth + (sourcePPW - 1)) / sourcePPW) * 4;
-		sourceBitsSize = interpreterProxy->byteSizeOf(sourceBits);
-		if (!((interpreterProxy->isWordsOrBytes(sourceBits)) && (sourceBitsSize == (sourcePitch * sourceHeight)))) {
+		sourceBitsSize = interpreterProxy->byteSizeOf(sourceBitsOop_xxx_dmu);
+		if (!((interpreterProxy->isWordsOrBytes(sourceBitsOop_xxx_dmu)) && (sourceBitsSize == (sourcePitch * sourceHeight)))) {
 			return 0;
 		}
-		sourceBits = oopForPointer(interpreterProxy->firstIndexableField(sourceBits));
+		// xxx_dmu sourceBits = oopForPointer(interpreterProxy->firstIndexableField(sourceBits));
+		sourceBits = (sqInt)(interpreterProxy->firstIndexableField(sourceBitsOop_xxx_dmu));
 	}
 	return 1;
 }
 
 
-/*	ColorMap, if not nil, must be longWords, and 
-	2^N long, where N = sourceDepth for 1, 2, 4, 8 bits, 
+/*	ColorMap, if not nil, must be longWords, and
+	2^N long, where N = sourceDepth for 1, 2, 4, 8 bits,
 	or N = 9, 12, or 15 (3, 4, 5 bits per color) for 16 or 32 bits. */
 
 static sqInt loadColorMap(void) {
@@ -2977,7 +3014,7 @@ static sqInt loadColorMap(void) {
 	cmShiftTable = null;
 	cmMaskTable = null;
 	cmLookupTable = null;
-	cmOop = interpreterProxy->fetchPointerofObject(BBColorMapIndex, bitBltOop);
+	cmOop = interpreterProxy->fetchPointerofObject(BBColorMapIndex, bitBltOop); // OK xxx_dmu
 	if (cmOop == (interpreterProxy->nilObject())) {
 		return 1;
 	}
@@ -2995,7 +3032,7 @@ static sqInt loadColorMap(void) {
 			return 0;
 		}
 		/* begin loadColorMapShiftOrMaskFrom: */
-		mapOop = interpreterProxy->fetchPointerofObject(0, cmOop);
+		mapOop = interpreterProxy->fetchPointerofObject(0, cmOop);  // OK xxx_dmu
 		if (mapOop == (interpreterProxy->nilObject())) {
 			cmShiftTable = null;
 			goto l1;
@@ -3013,7 +3050,7 @@ static sqInt loadColorMap(void) {
 		cmShiftTable = interpreterProxy->firstIndexableField(mapOop);
 	l1:	/* end loadColorMapShiftOrMaskFrom: */;
 		/* begin loadColorMapShiftOrMaskFrom: */
-		mapOop1 = interpreterProxy->fetchPointerofObject(1, cmOop);
+		mapOop1 = interpreterProxy->fetchPointerofObject(1, cmOop); // maybe xxx_dmu
 		if (mapOop1 == (interpreterProxy->nilObject())) {
 			cmMaskTable = null;
 			goto l2;
@@ -3030,7 +3067,7 @@ static sqInt loadColorMap(void) {
 		}
 		cmMaskTable = interpreterProxy->firstIndexableField(mapOop1);
 	l2:	/* end loadColorMapShiftOrMaskFrom: */;
-		oop = interpreterProxy->fetchPointerofObject(2, cmOop);
+		oop = interpreterProxy->fetchPointerofObject(2, cmOop);  // OK xxx_dmu
 		if (oop == (interpreterProxy->nilObject())) {
 			cmSize = 0;
 		} else {
@@ -3112,7 +3149,8 @@ static sqInt loadHalftoneForm(void) {
 		halftoneBits = halftoneForm;
 		halftoneHeight = interpreterProxy->slotSizeOf(halftoneBits);
 	}
-	halftoneBase = oopForPointer(interpreterProxy->firstIndexableField(halftoneBits));
+	// xxx_dmu halftoneBase = oopForPointer(interpreterProxy->firstIndexableField(halftoneBits));
+	halftoneBase = (sqInt)(interpreterProxy->firstIndexableField(halftoneBits));
 	return 1;
 }
 
@@ -3132,13 +3170,13 @@ static sqInt loadWarpBltFrom(sqInt bbObj) {
 
 
 /*	Get a pointer to the bits of any OS surfaces. */
-/*	Notes: 
+/*	Notes:
 	* For equal source/dest handles only one locking operation is performed.
 	This is to prevent locking of overlapping areas which does not work with
-	certain APIs (as an example, DirectDraw prevents locking of overlapping areas). 
-	A special case for non-overlapping but equal source/dest handle would 
-	be possible but we would have to transfer this information over to 
-	unlockSurfaces somehow (currently, only one unlock operation is 
+	certain APIs (as an example, DirectDraw prevents locking of overlapping areas).
+	A special case for non-overlapping but equal source/dest handle would
+	be possible but we would have to transfer this information over to
+	unlockSurfaces somehow (currently, only one unlock operation is
 	performed for equal source and dest handles). Also, this would require
 	a change in the notion of ioLockSurface() which is right now interpreted
 	as a hint and not as a requirement to lock only the specific portion of
@@ -3197,6 +3235,7 @@ static sqInt lockSurfaces(void) {
 					sourceBits = fn(sourceHandle, &sourcePitch, 0,0, sourceWidth, sourceHeight);
 				}
 				destBits = sourceBits;
+        destBitsOop_xxx_dmu = sourceBitsOop_xxx_dmu;
 				destPitch = sourcePitch;
 				hasSurfaceLock = 1;
 				return destBits != 0;
@@ -3557,7 +3596,7 @@ static sqInt pickSourcePixelsflagssrcMaskdestMasksrcShiftIncdstShiftInc(sqInt nP
 
 	/* begin srcLongAt: */
 	idx2 = sourceIndex;
-	sourceWord = long32At(idx2);
+	sourceWord = long32AtPointer(idx2);
 	destWord = 0;
 
 	/* Hint: Keep in register */
@@ -3591,7 +3630,7 @@ static sqInt pickSourcePixelsflagssrcMaskdestMasksrcShiftIncdstShiftInc(sqInt nP
 				}
 				/* begin srcLongAt: */
 				idx = sourceIndex += 4;
-				sourceWord = long32At(idx);
+				sourceWord = long32AtPointer(idx);
 			}
 		} while(!((nPix -= 1) == 0));
 	} else {
@@ -3631,7 +3670,7 @@ static sqInt pickSourcePixelsflagssrcMaskdestMasksrcShiftIncdstShiftInc(sqInt nP
 				}
 				/* begin srcLongAt: */
 				idx1 = sourceIndex += 4;
-				sourceWord = long32At(idx1);
+				sourceWord = long32AtPointer(idx1);
 			}
 		} while(!((nPix -= 1) == 0));
 	}
@@ -3661,7 +3700,7 @@ static sqInt pickWarpPixelAtXy(sqInt xx, sqInt yy) {
 
 	/* Extract pixel from word */
 
-	sourceWord = long32At(srcIndex);
+	sourceWord = long32AtPointer(srcIndex);
 	srcBitShift = warpBitShiftTable[x & warpAlignMask];
 	sourcePix = (((usqInt) sourceWord) >> srcBitShift) & warpSrcMask;
 	return sourcePix;
@@ -3810,18 +3849,22 @@ EXPORT(sqInt) primitiveDisplayString(void) {
     sqInt startBits;
 
 	if (!((interpreterProxy->methodArgumentCount()) == 6)) {
+    //fprintf(stderr, "failed arg count\n");
 		return interpreterProxy->primitiveFail();
 	}
 	kernDelta = interpreterProxy->stackIntegerValue(0);
 	xTable = interpreterProxy->stackObjectValue(1);
 	glyphMap = interpreterProxy->stackObjectValue(2);
 	if (!(((interpreterProxy->fetchClassOf(xTable)) == (interpreterProxy->classArray())) && ((interpreterProxy->fetchClassOf(glyphMap)) == (interpreterProxy->classArray())))) {
+    //fprintf(stderr, "failed 3831\n");
 		return interpreterProxy->primitiveFail();
 	}
 	if (!((interpreterProxy->slotSizeOf(glyphMap)) == 256)) {
+    //fprintf(stderr, "failed 3834\n");
 		return interpreterProxy->primitiveFail();
 	}
 	if (interpreterProxy->failed()) {
+    //fprintf(stderr, "failed 3838\n");
 		return null;
 	}
 	maxGlyph = (interpreterProxy->slotSizeOf(xTable)) - 2;
@@ -3829,16 +3872,20 @@ EXPORT(sqInt) primitiveDisplayString(void) {
 	startIndex = interpreterProxy->stackIntegerValue(4);
 	sourceString = interpreterProxy->stackObjectValue(5);
 	if (!(interpreterProxy->isBytes(sourceString))) {
+    //fprintf(stderr, "failed 3846\n");
 		return interpreterProxy->primitiveFail();
 	}
 	if (!((startIndex > 0) && ((stopIndex > 0) && (stopIndex <= (interpreterProxy->byteSizeOf(sourceString)))))) {
+    //fprintf(stderr, "failed 3850\n");
 		return interpreterProxy->primitiveFail();
 	}
 	bbObj = interpreterProxy->stackObjectValue(6);
 	if (!(loadBitBltFromwarping(bbObj, 0))) {
+    //fprintf(stderr, "failed 3855\n");
 		return interpreterProxy->primitiveFail();
 	}
 	if ((combinationRule == 30) || (combinationRule == 31)) {
+    //fprintf(stderr, "failed 3859\n");
 		return interpreterProxy->primitiveFail();
 	}
 	quickBlt = (destBits != 0) && ((sourceBits != 0) && ((noSource == 0) && ((sourceForm != destForm) && ((cmFlags != 0) || ((sourceMSB != destMSB) || (sourceDepth != destDepth))))));
@@ -3848,11 +3895,13 @@ EXPORT(sqInt) primitiveDisplayString(void) {
 		ascii = byteAtPointer((sourcePtr + charIndex) - 1);
 		glyphIndex = interpreterProxy->fetchIntegerofObject(ascii, glyphMap);
 		if ((glyphIndex < 0) || (glyphIndex > maxGlyph)) {
+      //fprintf(stderr, "failed 3869\n");
 			return interpreterProxy->primitiveFail();
 		}
 		sourceX = interpreterProxy->fetchIntegerofObject(glyphIndex, xTable);
 		width = (interpreterProxy->fetchIntegerofObject(glyphIndex + 1, xTable)) - sourceX;
 		if (interpreterProxy->failed()) {
+      //fprintf(stderr, "failed 3875\n");
 			return null;
 		}
 		clipRange();
@@ -3892,6 +3941,7 @@ EXPORT(sqInt) primitiveDisplayString(void) {
 			}
 		}
 		if (interpreterProxy->failed()) {
+      //fprintf(stderr, "failed 3915\n");
 			return null;
 		}
 		destX = (destX + width) + kernDelta;
@@ -4547,7 +4597,7 @@ static sqInt sourceWordwith(sqInt sourceWord, sqInt destinationWord) {
 }
 
 static sqInt srcLongAt(sqInt idx) {
-	return long32At(idx);
+	return long32AtPointer(idx);
 }
 
 static sqInt subWordwith(sqInt sourceWord, sqInt destinationWord) {
@@ -4563,8 +4613,8 @@ static sqInt tableLookupat(unsigned int * table, sqInt index) {
 
 
 /*	Tally pixels into the color map.  Those tallied are exactly those
-	in the destination rectangle.  Note that the source should be 
-	specified == destination, in order for the proper color map checks 
+	in the destination rectangle.  Note that the source should be
+	specified == destination, in order for the proper color map checks
 	to be performed at setup. */
 
 static sqInt tallyIntoMapwith(sqInt sourceWord, sqInt destinationWord) {
@@ -4707,7 +4757,7 @@ static sqInt tallyMapAtput(sqInt idx, sqInt value) {
 
 
 /*	Shortcut for stuff that's being run from the balloon engine.
-	Since we do this at each scan line we should avoid the expensive 
+	Since we do this at each scan line we should avoid the expensive
 	setup for source and destination. */
 
 static sqInt tryCopyingBitsQuickly(void) {
@@ -4763,7 +4813,7 @@ static sqInt unlockSurfaces(void) {
 		}
 		fn = ((sqInt (*)(sqInt, sqInt, sqInt, sqInt, sqInt)) unlockSurfaceFn);
 		destLocked = 0;
-		destHandle = interpreterProxy->fetchPointerofObject(FormBitsIndex, destForm);
+		destHandle = interpreterProxy->fetchPointerofObject(FormBitsIndex, destForm); // maybe xxx_dmu
 		if ((destHandle & 1)) {
 
 			/* The destBits are always assumed to be dirty */
@@ -4774,7 +4824,7 @@ static sqInt unlockSurfaces(void) {
 			destLocked = 1;
 		}
 		if (!(noSource)) {
-			sourceHandle = interpreterProxy->fetchPointerofObject(FormBitsIndex, sourceForm);
+			sourceHandle = interpreterProxy->fetchPointerofObject(FormBitsIndex, sourceForm); // maybe xxx_dmu
 			if ((sourceHandle & 1)) {
 
 				/* Only unlock sourceHandle if different from destHandle */
@@ -4870,6 +4920,7 @@ static sqInt warpLoop(void) {
     sqInt mergeWord;
     sqInt pBx;
     sqInt sourceMapOop;
+    sqInt sourceMapIndex_xxx_dmu;
     sqInt nSteps;
     sqInt halftoneWord;
     sqInt pAy;
@@ -5002,11 +5053,13 @@ l6:	/* end deltaFrom:to:nSteps: */;
 			if ((interpreterProxy->slotSizeOf(sourceMapOop)) < (1 << sourceDepth)) {
 				return interpreterProxy->primitiveFail();
 			}
-			sourceMapOop = oopForPointer(interpreterProxy->firstIndexableField(sourceMapOop));
+			// xxx_dmu sourceMapOop = oopForPointer(interpreterProxy->firstIndexableField(sourceMapOop));
+			sourceMapIndex_xxx_dmu = (sqInt)(interpreterProxy->firstIndexableField(sourceMapOop));
 		}
 	} else {
 		smoothingCount = 1;
 		sourceMapOop = interpreterProxy->nilObject();
+    sourceMapIndex_xxx_dmu = 0;
 	}
 	nSteps = width - 1;
 	if (nSteps <= 0) {
@@ -5108,7 +5161,7 @@ l6:	/* end deltaFrom:to:nSteps: */;
 		} else {
 			/* begin halftoneAt: */
 			idx = (dy + i) - 1;
-			halftoneWord = long32At(halftoneBase + ((idx % halftoneHeight) * 4));
+			halftoneWord = long32AtPointer(halftoneBase + ((idx % halftoneHeight) * 4));
 		}
 		destMask = mask1;
 
@@ -5132,7 +5185,7 @@ l6:	/* end deltaFrom:to:nSteps: */;
 							goto l7;
 						}
 						srcIndex = (sourceBits + (y * sourcePitch)) + ((((usqInt) x) >> warpAlignShift) * 4);
-						sourceWord = long32At(srcIndex);
+						sourceWord = long32AtPointer(srcIndex);
 						srcBitShift = warpBitShiftTable[x & warpAlignMask];
 						sourcePix1 = (((usqInt) sourceWord) >> srcBitShift) & warpSrcMask;
 						sourcePix = sourcePix1;
@@ -5153,7 +5206,7 @@ l6:	/* end deltaFrom:to:nSteps: */;
 							goto l8;
 						}
 						srcIndex1 = (sourceBits + (y1 * sourcePitch)) + ((((usqInt) x1) >> warpAlignShift) * 4);
-						sourceWord1 = long32At(srcIndex1);
+						sourceWord1 = long32AtPointer(srcIndex1);
 						srcBitShift = warpBitShiftTable[x1 & warpAlignMask];
 						sourcePix2 = (((usqInt) sourceWord1) >> srcBitShift) & warpSrcMask;
 						sourcePix = sourcePix2;
@@ -5184,7 +5237,7 @@ l6:	/* end deltaFrom:to:nSteps: */;
 				}
 				skewWord = destWord1;
 			} else {
-				skewWord = warpPickSmoothPixelsxDeltahyDeltahxDeltavyDeltavsourceMapsmoothingdstShiftInc(nPix, xDelta, yDelta, deltaP12x, deltaP12y, sourceMapOop, smoothingCount, dstShiftInc);
+				skewWord = warpPickSmoothPixelsxDeltahyDeltahxDeltavyDeltavsourceMapsmoothingdstShiftInc(nPix, xDelta, yDelta, deltaP12x, deltaP12y, sourceMapIndex_xxx_dmu, smoothingCount, dstShiftInc);
 			}
 			dstBitShift = dstShiftLeft;
 			if (destMask == AllOnes) {
@@ -5192,16 +5245,16 @@ l6:	/* end deltaFrom:to:nSteps: */;
 				/* begin dstLongAt:put: */
 				idx1 = destIndex;
 				value = destMask & mergeWord;
-				long32Atput(idx1, value);
+				long32AtPointerput(idx1, value);
 			} else {
 				/* begin dstLongAt: */
 				idx2 = destIndex;
-				destWord = long32At(idx2);
+				destWord = long32AtPointer(idx2);
 				mergeWord = mergeFnwith(skewWord & halftoneWord, destWord & destMask);
 				destWord = (destMask & mergeWord) | (destWord & (~destMask));
 				/* begin dstLongAt:put: */
 				idx3 = destIndex;
-				long32Atput(idx3, destWord);
+				long32AtPointerput(idx3, destWord);
 			}
 			destIndex += 4;
 			if (words == 2) {
@@ -5328,7 +5381,7 @@ static sqInt warpPickSmoothPixelsxDeltahyDeltahxDeltavyDeltavsourceMapsmoothingd
 					goto l1;
 				}
 				srcIndex = (sourceBits + (y1 * sourcePitch)) + ((((usqInt) x1) >> warpAlignShift) * 4);
-				sourceWord = long32At(srcIndex);
+				sourceWord = long32AtPointer(srcIndex);
 				srcBitShift = warpBitShiftTable[x1 & warpAlignMask];
 				sourcePix = (((usqInt) sourceWord) >> srcBitShift) & warpSrcMask;
 				rgb = sourcePix;
@@ -5336,7 +5389,7 @@ static sqInt warpPickSmoothPixelsxDeltahyDeltahxDeltavyDeltavsourceMapsmoothingd
 				if (!((combinationRule == 25) && (rgb == 0))) {
 					nPix += 1;
 					if (sourceDepth < 16) {
-						rgb = long32At(sourceMap + (rgb << 2));
+						rgb = long32AtPointer(sourceMap + (rgb << 2));
 					} else {
 						if (sourceDepth == 16) {
 							rgb = (((rgb & 31) << 3) | ((rgb & 992) << 6)) | ((rgb & 31744) << 9);
@@ -5449,7 +5502,7 @@ static sqInt warpPickSourcePixelsxDeltahyDeltahxDeltavyDeltavdstShiftIncflags(sq
 				goto l1;
 			}
 			srcIndex = (sourceBits + (y * sourcePitch)) + ((((usqInt) x) >> warpAlignShift) * 4);
-			sourceWord = long32At(srcIndex);
+			sourceWord = long32AtPointer(srcIndex);
 			srcBitShift = warpBitShiftTable[x & warpAlignMask];
 			sourcePix1 = (((usqInt) sourceWord) >> srcBitShift) & warpSrcMask;
 			sourcePix = sourcePix1;
@@ -5470,7 +5523,7 @@ static sqInt warpPickSourcePixelsxDeltahyDeltahxDeltavyDeltavdstShiftIncflags(sq
 				goto l2;
 			}
 			srcIndex1 = (sourceBits + (y1 * sourcePitch)) + ((((usqInt) x1) >> warpAlignShift) * 4);
-			sourceWord1 = long32At(srcIndex1);
+			sourceWord1 = long32AtPointer(srcIndex1);
 			srcBitShift = warpBitShiftTable[x1 & warpAlignMask];
 			sourcePix2 = (((usqInt) sourceWord1) >> srcBitShift) & warpSrcMask;
 			sourcePix = sourcePix2;
diff --git a/vm/src/from_squeak/intplugins/UnixOSProcessPlugin/UnixOSProcessPlugin.c b/vm/src/from_squeak/intplugins/UnixOSProcessPlugin/UnixOSProcessPlugin.c
index a641c00..ba255ba 100644
--- a/vm/src/from_squeak/intplugins/UnixOSProcessPlugin/UnixOSProcessPlugin.c
+++ b/vm/src/from_squeak/intplugins/UnixOSProcessPlugin/UnixOSProcessPlugin.c
@@ -2,6 +2,22 @@
 by VMMaker 3.8b6
  */
 
+// added bu dmu
+#define AIO_X	(1<<0)	/* handle for exceptions */
+#define AIO_R	(1<<1)	/* handle for read */
+#define AIO_W	(1<<2)	/* handle for write */
+#define AIO_SEQ	(1<<3)	/* call handlers sequentially  */
+#define AIO_EXT	(1<<4)	/* external fd -- don't close on aio shutdown  */
+
+#define AIO_RW	(AIO_R | AIO_W)
+#define AIO_RX	(AIO_R | AIO_X)
+#define AIO_WX	(AIO_W | AIO_X)
+
+#define AIO_RWX	(AIO_R | AIO_W | AIO_X)
+
+
+
+
 #include <math.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -45,6 +61,10 @@ by VMMaker 3.8b6
 #ifndef SQAIO_H
 # define SQAIO_H "aio.h"          /* aio.h has been renamed to sqaio.h */
 #endif
+# if Configure_Squeak_Code_for_Tilera  // xxx_dmu
+# undef SQAIO_H // xxx_dmu
+# define SQAIO_H "sqaio.h" // xxx_dmu
+# endif
 #include SQAIO_H
 #include "FilePlugin.h"
 #include "SocketPlugin.h"
@@ -1415,7 +1435,7 @@ EXPORT(sqInt) primitiveFileProtectionMask(void) {
 
 
 /*	Call stat(2) to obtain the file protection mask for a file. Answer errno on failure,
-	or on success answer an array with: UID with: GID with: protectionMask. The	
+	or on success answer an array with: UID with: GID with: protectionMask. The
 	protectionMask is an Array of four integers representing the protection mask, or
 	answer errno on failure. The protection mask is four Integers, each of which may
 	be considered an octal digit (0-7), with bit values 4, 2, and 1. The first digit selects
@@ -2470,7 +2490,7 @@ EXPORT(sqInt) primitiveSemaIndexFor(void) {
 
 	sigNum = interpreterProxy->stackIntegerValue(0);
 	index = semaIndices[sigNum];
-	interpreterProxy->pop(1);
+	interpreterProxy->pop(2); // Squeak bug, was 1
 	interpreterProxy->pushInteger(index);
 }
 
diff --git a/vm/src/from_squeak/unix/vm-display-X11/sqUnixX11.c b/vm/src/from_squeak/unix/vm-display-X11/sqrUnixX11.c
similarity index 98%
rename from vm/src/from_squeak/unix/vm-display-X11/sqUnixX11.c
rename to vm/src/from_squeak/unix/vm-display-X11/sqrUnixX11.c
index 5ef6be3..8514d4a 100644
--- a/vm/src/from_squeak/unix/vm-display-X11/sqUnixX11.c
+++ b/vm/src/from_squeak/unix/vm-display-X11/sqrUnixX11.c
@@ -1,34 +1,34 @@
 /* sqUnixX11.c -- support for display via the X Window System.
- * 
+ *
  *   Copyright (C) 1996-2005 by Ian Piumarta and other authors/contributors
  *                              listed elsewhere in this file.
  *   All rights reserved.
- *   
+ *
  *   This file is part of Unix Squeak.
- * 
+ *
  *      You are NOT ALLOWED to distribute modified versions of this file
  *      under its original name.  If you modify this file then you MUST
  *      rename it before making your modifications available publicly.
- * 
+ *
  *   This file is distributed in the hope that it will be useful, but WITHOUT
  *   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
  *   FITNESS FOR A PARTICULAR PURPOSE.
- *   
+ *
  *   You may use and/or distribute this file ONLY as part of Squeak, under
  *   the terms of the Squeak License as described in `LICENSE' in the base of
  *   this distribution, subject to the following additional restrictions:
- * 
+ *
  *   1. The origin of this software must not be misrepresented; you must not
  *      claim that you wrote the original software.  If you use this software
  *      in a product, an acknowledgment to the original author(s) (and any
  *      other contributors mentioned herein) in the product documentation
  *      would be appreciated but is not required.
- * 
+ *
  *   2. You must not distribute (or make publicly available by any
  *      means) a modified copy of this file unless you first rename it.
- * 
+ *
  *   3. This notice must not be removed or altered in any source distribution.
- * 
+ *
  *   Using (or modifying this file for use) in any context other than Squeak
  *   changes these copyright conditions.  Read the file `COPYING' in the
  *   directory `platforms/unix/doc' before proceeding with any such use.
@@ -40,7 +40,7 @@
  *
  * Support for more intelligent CLIPBOARD selection handling contributed by:
  *	Ned Konz <ned@bike-nomad.com>
- * 
+ *
  * Support for displays deeper than 8 bits contributed by: Kazuki YASUMATSU
  *	<kyasu@crl.fujixerox.co.jp> <Kazuki.Yasumatsu@fujixerox.co.jp>
  *
@@ -63,6 +63,8 @@
  *	Dave Lewis <lewis@mail.msen.com> Mon Oct 18 20:36:54 EDT 1999
  */
 
+# include "squeak_adapters.h"
+
 #include "sq.h"
 #include "sqMemoryAccess.h"
 
@@ -574,7 +576,7 @@ static int sendSelection(XSelectionRequestEvent *requestEv, int isMultiple)
   int xError= 0;
   XSelectionEvent notifyEv;
   Atom targetProperty= ((None == requestEv->property)
-			? requestEv->target 
+			? requestEv->target
 			: requestEv->property);
 
   notifyEv.property= targetProperty;
@@ -723,7 +725,7 @@ static int sendSelection(XSelectionRequestEvent *requestEv, int isMultiple)
     }
 
 #if defined(DEBUG_SELECTIONS)
-  if (xError == BadAlloc || xError == BadAtom || xError == BadMatch 
+  if (xError == BadAlloc || xError == BadAtom || xError == BadMatch
       || xError == BadValue || xError == BadWindow)
     fprintf(stderr, "sendSelection: XChangeProperty err %d\n", xError);
 #endif
@@ -963,7 +965,7 @@ static sqInt display_clipboardWriteFromAt(sqInt count, sqInt byteArrayIndex, sqI
 {
   if (allocateSelectionBuffer(count))
     {
-      memcpy((void *)stPrimarySelection, pointerForOop(byteArrayIndex + startIndex), count);
+      memcpy((void *)stPrimarySelection, (char*)pointerForIndex_xxx_dmu(byteArrayIndex + startIndex), count);
       stPrimarySelection[count]= '\0';
       claimSelection();
     }
@@ -984,7 +986,7 @@ static sqInt display_clipboardReadIntoAt(sqInt count, sqInt byteArrayIndex, sqIn
 #if defined(DEBUG_SELECTIONS)
   fprintf(stderr, "clipboard read: %d selectionSize %d\n", count, selectionSize);
 #endif
-  memcpy(pointerForOop(byteArrayIndex + startIndex), (void *)stPrimarySelection, clipSize);
+  memcpy((char*)pointerForIndex_xxx_dmu(byteArrayIndex + startIndex), (void *)stPrimarySelection, clipSize);
   return clipSize;
 }
 
@@ -1005,14 +1007,15 @@ static void redrawDisplay(int l, int r, int t, int b)
 
   sqInt displayObj= displayObject();
 
-  if ((((((unsigned)(oopAt(displayObj))) >> 8) & 15) <= 4)
+  if ((((((unsigned)( oopAt(displayObj) )) >> 8) & 15) <= 4)
       && ((lengthOf(displayObj)) >= 4))
     {
-      sqInt dispBits= fetchPointerofObject(0, displayObj);
+      sqInt dispBits= fetchPointerofObject(0, displayObj); // OK xxx_dmu
       sqInt w= fetchIntegerofObject(1, displayObj);
       sqInt h= fetchIntegerofObject(2, displayObj);
       sqInt d= fetchIntegerofObject(3, displayObj);
-      sqInt dispBitsIndex= dispBits + BaseHeaderSize;
+      // sqInt dispBitsIndex= dispBits + BaseHeaderSize; xxx_dmu
+      sqInt dispBitsIndex = (sqInt)firstFixedField(dispBits); // xxx_dmu
       ioShowDisplay(dispBitsIndex, w, h, d, (sqInt)l, (sqInt)r, (sqInt)t, (sqInt)b);
     }
 }
@@ -1225,7 +1228,7 @@ static int x2sqModifier(int state)
 	/* M - A - */ _|M|_|_,  _|M|_|S,  _|M|_|S,  _|M|_|_,
 	/* M - A C */ O|_|_|_,  O|M|_|S,  O|M|_|S,  O|M|_|_,
       };
-#    if defined(__POWERPC__) || defined(__ppc__)
+#    if defined(__POWERPC__) || defined(__ppc__) || Configure_Squeak_Code_for_Tilera // xxx_dmu
       mods= midofiers[state & 0x1f];
 #    else
       mods= midofiers[state & 0x0f];
@@ -1251,7 +1254,7 @@ static void waitForCompletions(void)
 
 static void handleEvent(XEvent *evt)
 {
-#if defined(DEBUG_EVENTS)
+ #if defined(DEBUG_EVENTS)
   switch (evt->type)
     {
     case ButtonPress:
@@ -1337,7 +1340,17 @@ static void handleEvent(XEvent *evt)
     case KeyPress:
       noteEventState(evt->xkey);
       {
-	int keyCode= x2sqKey(&evt->xkey);
+     	int keyCode= x2sqKey(&evt->xkey);
+      if (keyCode == 1  &&  modifierState == 3)  signal_emergency_semaphore();
+      if (keyCode == 1  &&  modifierState == 2)    /* ^a */ print_vm_info();
+# if Multiple_Tileras
+        extern void connect_to_other_chips();
+        extern void send_test_message();
+        
+      if (keyCode == 2  &&  modifierState == 3)  connect_to_other_chips();
+      if (keyCode == 5  &&  modifierState == 3)  send_test_message();//ctrl shift e
+# endif
+
 	if (keyCode >= 0)
 	  {
 	    recordKeyboardEvent(keyCode, EventKeyDown, modifierState);
@@ -1759,12 +1772,20 @@ void initWindow(char *displayName)
 
   XSetErrorHandler(xError);
 
-  stDisplay= XOpenDisplay(displayName);
+  // xxx_dmu Tilera sometimes takes time to initialize
+  int xxx_dmu;
+  for (xxx_dmu = 0;  xxx_dmu < 100;  ++xxx_dmu) {
+    stDisplay= XOpenDisplay(displayName);
+    if (stDisplay) break;
+    if (xxx_dmu == 0) fprintf(stderr, "Retrying display\n");
+    sleep(1);
+  }
   if (!stDisplay)
     {
       fprintf(stderr, "Could not open display `%s'.\n", displayName);
       exit(1);
     }
+  if (xxx_dmu != 0) fprintf(stderr, "had to try %d times\n", xxx_dmu + 1);
 
   /* get screen size */
   scrH= (DisplayHeight(stDisplay, DefaultScreen(stDisplay)));
@@ -2136,7 +2157,7 @@ static sqInt display_ioFormPrint(sqInt bitsIndex, sqInt width, sqInt height, sqI
 {
 # if defined(PRINT_PS_FORMS)
 
-  char *bitsAddr= pointerForOop(bitsIndex);
+  char *bitsAddr= pointerForIndex_xxx_dmu(bitsIndex);
   FILE *ppm;
   float scale;			/* scale to use with pnmtops */
   char printCommand[1000];
@@ -2372,8 +2393,8 @@ static unsigned char swapBits(unsigned char in)
 
 static sqInt display_ioSetCursorWithMask(sqInt cursorBitsIndex, sqInt cursorMaskIndex, sqInt offsetX, sqInt offsetY)
 {
-  unsigned int *cursorBits= (unsigned int *)pointerForOop(cursorBitsIndex);
-  unsigned int *cursorMask= (unsigned int *)pointerForOop(cursorMaskIndex);
+  unsigned int *cursorBits= (unsigned int *)pointerForIndex_xxx_dmu(cursorBitsIndex);
+  unsigned int *cursorMask= (unsigned int *)pointerForIndex_xxx_dmu(cursorMaskIndex);
   unsigned char data[32], mask[32];	/* cursors are always 16x16 */
   int i;
   Cursor cursor;
@@ -2677,7 +2698,7 @@ static sqInt display_ioShowDisplay(sqInt dispBitsIndex, sqInt width, sqInt heigh
   static sqInt  stDisplayHeight= 0;	/* ditto height */
   static sqInt  stDisplayDepth= 0;	/* ditto depth */
 
-  char *dispBits= pointerForOop(dispBitsIndex);
+  char *dispBits= pointerForIndex_xxx_dmu(dispBitsIndex);
 
   int geometryChanged= ((stDisplayBits != dispBits)
 			|| (stDisplayWidth  != width)
@@ -3981,7 +4002,7 @@ static int visualAttributes[]= {
   GLX_RGBA,                 /* no indexed colors */
   GLX_DOUBLEBUFFER,         /* will swap */
   GLX_LEVEL,            0,  /* frame buffer, not overlay */
-  GLX_DEPTH_SIZE,       16, /* decent depth */   
+  GLX_DEPTH_SIZE,       16, /* decent depth */
   GLX_AUX_BUFFERS,      0,  /* no aux buffers */
   GLX_ACCUM_RED_SIZE,   0,  /* no accumulation */
   GLX_ACCUM_GREEN_SIZE, 0,
@@ -4005,7 +4026,7 @@ static sqInt display_ioGLcreateRenderer(glRenderer *r, sqInt x, sqInt y, sqInt w
 
   if (flags & B3D_STENCIL_BUFFER)
     visualAttributes[1]= 1;
-  else 
+  else
     visualAttributes[1]= 0;
   _renderWindow(r)= 0;
   _renderContext(r)= 0;
@@ -4059,7 +4080,7 @@ static sqInt display_ioGLcreateRenderer(glRenderer *r, sqInt x, sqInt y, sqInt w
       valuemask|= CWBackPixel;
 
       if (!(_renderWindow(r)= (void *)XCreateWindow(stDisplay, stWindow, x, y, w, h, 0,
-						    visinfo->depth, InputOutput, visinfo->visual, 
+						    visinfo->depth, InputOutput, visinfo->visual,
 						    valuemask, &attributes)))
 	{
 	  DPRINTF(1, (fp, "Failed to create client window\r"));
@@ -4137,9 +4158,9 @@ static void display_ioGLsetBufferRect(glRenderer *r, sqInt x, sqInt y, sqInt w,
 
 static void printVisual(XVisualInfo* visinfo)
 {
-  int isOpenGL; 
+  int isOpenGL;
   glXGetConfig(stDisplay, visinfo, GLX_USE_GL, &isOpenGL);
-  if (isOpenGL) 
+  if (isOpenGL)
     {
       int slow= 0;
       int red, green, blue, alpha, stencil, depth;
@@ -4167,7 +4188,7 @@ static void listVisuals(void)
 {
   XVisualInfo* visinfo;
   int nvisuals, i;
-   
+
   visinfo= XGetVisualInfo(stDisplay, VisualNoMask, NULL, &nvisuals);
 
   for (i= 0; i < nvisuals; i++)
